// D3DFrame.cpp: CD3DFrame NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "D3DFrame.h"
#include "inc.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CD3DFrame::CD3DFrame()
{
	m_pFrame = NULL;
}

CD3DFrame::~CD3DFrame()
{
	Release();
}

void CD3DFrame::Initialize(IDirect3DRMFrame3** ppF)
{
	m_pFrame = *ppF;
	m_pFrame->AddRef();
}

void CD3DFrame::Release()
{
	if( m_pFrame!=NULL )
	{
		m_pFrame->Release();
		m_pFrame=NULL;
	}
}

void CD3DFrame::AddMeshBuilder(CD3DMeshBuilder * pM)
{
	if( m_pFrame==NULL )
		return;

	m_pFrame->AddVisual( (LPDIRECT3DRMVISUAL)(pM->m_pMesh) );
}

void CD3DFrame::AddLight(CD3DLight * pL)
{
	if( m_pFrame==NULL )
		return;

	m_pFrame->AddLight( pL->m_pLight );
}

void CD3DFrame::SetPosition(CD3DFrame * pRef, CVector & pos)
{
	if( m_pFrame==NULL )
		return;

	if( pRef!=NULL )
		m_pFrame->SetPosition( pRef->m_pFrame,D3DVEC(pos) );
	else
		m_pFrame->SetPosition( NULL,D3DVEC(pos) );
}

void CD3DFrame::SetDirection(CD3DFrame * pRef, CVector& dir, CVector& up)
{
	if( m_pFrame==NULL )
		return;

	if( pRef!=NULL )
		m_pFrame->SetOrientation( pRef->m_pFrame,D3DVEC(dir),D3DVEC(up) );
	else
		m_pFrame->SetOrientation( NULL,D3DVEC(dir),D3DVEC(up) );
}
