// DirectDraw.cpp: CDirectDraw NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectDraw.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDirectDraw::CDirectDraw()
{
	m_pDirectDraw = NULL;
	m_pPrim = NULL;

	m_bInit = false;
}

CDirectDraw::~CDirectDraw()
{
	ReleaseAll();
}

void CDirectDraw::ReleaseAll()
{
	if( m_pPrim!=NULL )
	{
		m_pPrim->Release();
		m_pPrim = NULL;
	}
	if( m_pDirectDraw!=NULL )
	{
		m_pDirectDraw->RestoreDisplayMode();
		m_pDirectDraw->Release();
		m_pDirectDraw = NULL;
	}
	m_bInit = false;
}

bool CDirectDraw::Initialize(HWND hwnd , int sizeX,int sizeY,int BPP)
{
	HRESULT	hr;
	DDCAPS Dummy;

	//  DircetDraw mۂĂꍇA֘AIuWFNgj
	ReleaseAll();

	// DirectDrawhCo񋓂
	IDirectDraw* pDD;
	DirectDrawEnumerate(DDEnumCallback,this);
	// 񋓂ɂDirectDrawhCo肵ȂꍇAHELp
	if (!m_pDirectDraw)
	{
		hr = DirectDrawCreate(NULL, &pDD, NULL);
		if( hr!=DD_OK )
			return false;
		pDD->QueryInterface(IID_IDirectDraw4,(LPVOID*)&m_pDirectDraw);
	}

	// DirectDraw̔\͂擾
	memset(&m_DriverCaps, 0, sizeof(m_DriverCaps));
	m_DriverCaps.dwSize = sizeof(m_DriverCaps);
	Dummy.dwSize = sizeof(Dummy);
	m_pDirectDraw->GetCaps(&m_DriverCaps, &Dummy);

	// xݒ
	hr = m_pDirectDraw->SetCooperativeLevel( hwnd,DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );
	if( hr!=DD_OK )
		return false;
	// fBXvC[hݒ
	hr = m_pDirectDraw->SetDisplayMode( sizeX, sizeY, BPP , 0 , 0 );
	if( hr!=DD_OK )
		return false;
	m_Bpp = BPP;

	DDSURFACEDESC2 desc;
	memset(&desc, 0, sizeof(desc));
	desc.dwSize = sizeof(desc);
	desc.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	desc.ddsCaps.dwCaps =	DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | 
							DDSCAPS_COMPLEX | DDSCAPS_3DDEVICE;
	desc.dwBackBufferCount = 1;

	// vC}T[tFX𐶐
	hr = m_pDirectDraw->CreateSurface( &desc,&m_pPrim,NULL );
	if( hr!=DD_OK )
		return false;

	m_bInit = true;
	return true;
}

BOOL CALLBACK DDEnumCallback(GUID FAR* lpGUID, LPSTR lpDriverDesc, LPSTR lpDriverName, LPVOID lpContext)
{
	CDirectDraw *pDD = (CDirectDraw*)lpContext;
	IDirectDraw* pIDD;
	DDCAPS DriverCaps, HELCaps;

	if(lpGUID)
	{
		// DirectDraw IuWFNgIɐ
		if ( DirectDrawCreate(lpGUID, &pIDD, NULL) != DD_OK )
			return FALSE;

		// DirectDraw̔\͂擾
		memset(&DriverCaps, 0, sizeof(DriverCaps));
		DriverCaps.dwSize = sizeof(DriverCaps);
		memset(&HELCaps, 0, sizeof(HELCaps));
		HELCaps.dwSize = sizeof(HELCaps);

		if( pIDD->GetCaps(&DriverCaps, &HELCaps) != DD_OK )
			return FALSE;

		if(DriverCaps.dwCaps & DDCAPS_3D)
		{
			if ( DriverCaps.ddsCaps.dwCaps & DDSCAPS_TEXTURE )
			{
				IDirectDraw4* pIDD4;
				pIDD->QueryInterface(IID_IDirectDraw4,(LPVOID*)&pIDD4);
				pDD->m_pDirectDraw = pIDD4;
				return DDENUMRET_CANCEL;
			}
		}

		// ̃hCoʖڂȂ̂Ŏ߂
		pIDD->Release();
	}

	return DDENUMRET_OK;
}

void CDirectDraw::Flip()
{
	if( m_pPrim==NULL )
		return;

	HRESULT hr;
	hr = m_pPrim->Flip(NULL,DDFLIP_WAIT);

	if( hr == DDERR_SURFACELOST )
	{
		m_pPrim->Restore();
		m_pPrim->Flip(NULL,DDFLIP_WAIT); 
	}
}

// obNobt@ԂB
bool CDirectDraw::GetBackSurface(CDirectDrawSurface* pS)
{
	if( !m_bInit )
		return false;

	IDirectDrawSurface4* sf;

	DDSCAPS2 ddscaps;
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	if( m_pPrim->GetAttachedSurface( &ddscaps,&sf ) != DD_OK )
		return false;

	pS->Initialize(&sf);
	sf->Release();
	return true;
}

// TCYŃT[tFX
bool CDirectDraw::CreateSurface(CDirectDrawSurface* pS,int sizeX,int sizeY)
{
	if( !m_bInit )
		return false;
	IDirectDrawSurface4* sf;

	DDSURFACEDESC2 ddsd;
	memset( &ddsd, 0,sizeof( ddsd ) );
	ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
    ddsd.dwWidth = sizeX;
    ddsd.dwHeight = sizeY;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;// | DDSCAPS_SYSTEMMEMORY;
	if( DD_OK != m_pDirectDraw->CreateSurface( &ddsd, &sf, NULL ) )
		return false;

	pS->Initialize(&sf);
	sf->Release();
	return true;
}

// rbg}bv[h
bool CDirectDraw::CreateSurface(CDirectDrawSurface* pS,LPCTSTR bmpName)
{
	if( !m_bInit )
		return false;
	HBITMAP hbm = (HBITMAP)LoadImage(NULL, bmpName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if( !hbm )
		return false;

    BITMAP bm;
    GetObject(hbm, sizeof(bm), &bm);

	CreateSurface(pS,bm.bmWidth,bm.bmHeight);

	HDC hdc , hdcImage;
	hdcImage = CreateCompatibleDC(NULL);
	SelectObject(hdcImage, hbm);

	pS->GetDC(&hdc);
		StretchBlt(hdc, 0, 0, bm.bmWidth , bm.bmHeight , 
					hdcImage, 0, 0, bm.bmWidth , bm.bmHeight, SRCCOPY);
	pS->ReleaseDC(hdc);

    DeleteDC(hdcImage);
    DeleteObject(hbm);

	return true;
}

// ʂɍ
bool CDirectDraw::CreateSurface(CDirectDrawSurface* pS,DDSURFACEDESC2 * desc)
{
	if( !m_bInit )
		return false;
	IDirectDrawSurface4* sf;
	HRESULT hr;
	hr = m_pDirectDraw->CreateSurface(desc, &sf, NULL);
	if( hr!=DD_OK )
		return false;

	pS->Initialize(&sf);
	sf->Release();
	return true;
}

void CDirectDraw::RestoreAll()
{
	if( !m_bInit )
		return;

	m_pDirectDraw->RestoreAllSurfaces();
}
